<?php /*

Favatise.php
Part of the Favatars wordpress plugin: 
http://dev.wp-plugins.org/wiki/favatars

This file will run through every comment, 
trackback, and pingback on your blog and
attempt to discover a favatar for each.

This file should be uploaded next to your
index.php file, and then called from a
web browser. Then you just watch it go.

*/
DEFINE(SP,'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;');
?>
<?php require('./wp-blog-header.php'); ?>

<h1>Favatise</h1>
<p>Use this script to file through every single comment, trackback, and pingback on your site and attempt to discover a favatar for each.</p>
<hr />

<?php if($_GET[clear] == 1) { 
	//hidden feature, will clear all comment favicons
	$comments = $wpdb->get_results("UPDATE `$tablecomments` SET `comment_favicon_url` = ''");
}	
?>

<?php if($_GET[start] == 1) { ?>

	<?php

	function super_flush() {
		// Because some logs are just too big for flush()...
		flush();
		ob_flush();
		flush();
		ob_flush();
		flush();
		ob_flush();
	}

	$request = "SELECT comment_ID, comment_author_url FROM $tablecomments WHERE comment_favicon_url = '' AND comment_author_url != '' ";

    $comments = $wpdb->get_results($request);

	$processed_urls = array();

    if ($comments) {
        foreach ($comments as $comment) {

			super_flush();
			echo("Updating Comment: $comment->comment_ID (<a href=\"$comment->comment_author_url\">$comment->comment_author_url</a>) ... <br />");
			super_flush();

			if(!empty($processed_urls[$comment->comment_author_url])) {
				// commenter url already cached, don't reprocess

				if($processed_urls[$comment->comment_author_url] == 'none') {
					// empty one discovered, skip it.
					echo(SP."<em>Cached: Couldn't find a favicon</em><br />\n");
				} else {
					// normal favicon, go ahead.
					$wpdb->query("UPDATE `$tablecomments` SET `comment_favicon_url` = '" . $processed_urls[$comment->comment_author_url] . "' WHERE `comment_ID` = '$comment->comment_ID' LIMIT 1");
					echo(SP."<em>Cached: Successful</em><br />\n");
				}

			} else {
				// Not in the cached array.

				if( $favicon_url = getFavicon($comment->comment_author_url) ) {
					$wpdb->query("UPDATE `$tablecomments` SET `comment_favicon_url` = '$favicon_url' WHERE `comment_ID` = '$comment->comment_ID' LIMIT 1");
					$processed_urls[$comment->comment_author_url] = $favicon_url;
					echo(SP."Successful<br />\n");
				} else {
					$processed_urls[$comment->comment_author_url] = 'none';
					echo(SP."No luck. Couldn't find a favicon<br />\n");
				} 

			}
				
			super_flush();
			usleep(500000);
			
        }
    }

	?>

	<h1>Update Complete!</h1>
	<p>You blog should now be all favatar'ed up!</p>	
	<p><em>You can <a href="wp-admin/options-reading.php">turn on gzip compression</a> again if you'd like</em></p>

<?php } else { ?>

	<p><strong>WARNING: THIS SCRIPT IS HARD CORE</strong><br />
	It may bring your server to it's knees, it may not. Regardless, it's going to take a very long time - the script has to parse every single comment. So please, don't come crying if it goes *boom*</p>
	
	<p>With that said, this script <em>shouldn't</em> do anything destructive - it'd most likely just fail to work.</p> 

	<p><em>Also of note, because of the way it's created, you can run this as many times as you want. Comments that have a url, but are without a favatar will be rescanned each time.</em></p>

	<?php if( get_settings('gzipcompression') ) { ?>
		<p><em>Before you can begin, you have to <a href="wp-admin/options-reading.php">turn off gzip compression</a>. Sorry! You can turn it back on once we're done here.</em></a></p>
	<?php } else { ?>
		<p>Ok, with the warning out of the way, <a href="favatise.php?start=1">begin generating favatars for all comments.</a></p>
	<?php } ?>

<?php } ?>